/*
This file is part of web2w.
Copyright 2017 Martin Ruckert

web2w is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

web2w is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with web2w.  If not, see <http://www.gnu.org/licenses/>.
 
Martin Ruckert, Hochschule Muenchen, Lothstrasse 64, 80336 Muenchen
*/
	/*3:*/
	#line 1108 "web2w.w"

	/*4:*/
	#line 1120 "web2w.w"

extern int ww_lex(void);
extern FILE*ww_in;
extern FILE*ww_out;
	/*:4*/	/*6:*/
	#line 1164 "web2w.w"

#define TEX INITIAL
	/*:6*/	/*7:*/
	#line 1225 "web2w.w"

typedef struct token{
int tag;
struct token*next,*previous,*link,*up;
union{
	/*8:*/
	#line 1242 "web2w.w"

struct{
int sequence_no;
int line_no;
	/*9:*/
	#line 1256 "web2w.w"

char*text;
	/*:9*/	/*39:*/
	#line 1605 "web2w.w"

int sym_no;
struct symbol*sym_ptr;
	/*:39*/	/*77:*/
	#line 2355 "web2w.w"

int pp_sp;
	/*:77*/
	#line 1246 "web2w.w"

}
	/*:8*/
	#line 1230 "web2w.w"
;
	/*100:*/
	#line 2813 "web2w.w"

struct{
long int value;
}
	/*:100*/
	#line 1231 "web2w.w"
;
};
}token;
	/*:7*/	/*10:*/
	#line 1266 "web2w.w"

extern const char*tagname(int tag);
	/*:10*/	/*15:*/
	#line 1300 "web2w.w"

extern int ww_lineno;
	/*:15*/	/*17:*/
	#line 1309 "web2w.w"

extern int sequence_no;
#define SEQ (sequence_no++)
	/*:17*/	/*18:*/
	#line 1317 "web2w.w"

void seq(token*t,token*s);
	/*:18*/	/*20:*/
	#line 1330 "web2w.w"

extern token*add_token(int tag);
	/*:20*/	/*22:*/
	#line 1342 "web2w.w"

extern token*last_token;
	/*:22*/	/*25:*/
	#line 1375 "web2w.w"

#define TOK(string,tag)  (add_token(tag)->text= string)
	/*:25*/	/*26:*/
	#line 1388 "web2w.w"

#define COPY  copy_string(ww_text)
	/*:26*/	/*27:*/
	#line 1405 "web2w.w"

#define CTL     pre_ctl_mode= YY_START;BEGIN(CONTROL)
#define END_CTL if (pre_ctl_mode!=TEX) TOK(end_string(),ATCTL); BEGIN(pre_ctl_mode)
	/*:27*/	/*28:*/
	#line 1418 "web2w.w"

#define BOS      new_string()
#define ADD      add_string(ww_text)
#define EOS      (string_length()>0?TOK(end_string(),TEXT):0)
	/*:28*/	/*29:*/
	#line 1430 "web2w.w"

extern char*new_string(void);
extern void add_string(char*str);
extern char*end_string(void);
extern char*copy_string(char*str);
extern int string_length(void);
	/*:29*/	/*34:*/
	#line 1526 "web2w.w"

typedef struct symbol{
char*name;
int tag;
struct symbol*link;
int use_count,scan_count,goto_count;
int arity,arg_count;
int is_string,is_int,is_label,is_global,is_extern,is_zero_based;
long int value;
token*type;
token*eq;
}symbol;
extern int sym_no(char*name);
extern symbol*symbol_table[];
	/*:34*/	/*40:*/
	#line 1611 "web2w.w"

#define SYM_PTR(name) symbol_table[sym_no(name)]
#define SYMBOL {int s= sym_no(ww_text);add_token(symbol_table[s]->tag)->sym_no= s;}
#define SYM(t) (symbol_table[(t)->sym_no])
	/*:40*/	/*42:*/
	#line 1646 "web2w.w"

extern void localize(token*t);
	/*:42*/	/*43:*/
	#line 1653 "web2w.w"

extern void scope_open(void);
extern void scope_close(void);
	/*:43*/	/*48:*/
	#line 1760 "web2w.w"

extern void ww_push(token*t);
extern token*ww_pop(token*t);
extern int ww_top_is(int tag);
	/*:48*/	/*50:*/
	#line 1806 "web2w.w"

#define PUSH      ww_push(last_token)
#define PUSH_NULL ww_push(NULL)
#define POP       ww_pop(last_token)
#define POP_NULL  (ADD, POP)
#define POP_MLEFT (EOS, TOK("}",RIGHT), BEGIN(MIDDLE),last_token->link= POP)
#define POP_PLEFT (EOS, TOK("}",RIGHT), BEGIN(PASCAL),last_token->link= POP)
#define POP_LEFT  (ww_top_is(MLEFT)? POP_MLEFT : (ww_top_is(PLEFT)? POP_PLEFT: POP_NULL))
	/*:50*/	/*54:*/
	#line 1856 "web2w.w"

typedef struct module{
token*atless;
token*atgreater;
struct module*left,*right;
}module;
extern void add_module(token*atless);
extern module*find_module(token*atless);
	/*:54*/	/*58:*/
	#line 1924 "web2w.w"

#define AT_GREATER_EQ TOK("@>",ATGREATER), add_module(POP), TOK("=",EQ), PUSH, SEQ
#define AT_GREATER    TOK("@>",ATGREATER), find_module(POP)
	/*:58*/	/*59:*/
	#line 1937 "web2w.w"

extern token*program;
#define PROGRAM (program->link= last_token,program= last_token),TOK("",EQ)
	/*:59*/	/*62:*/
	#line 1973 "web2w.w"

#define CHGTAG(t,x) ((t)->tag= (x))
#define CHGID(t,x)  (SYM(t)->tag= (x))
#define CHGTYPE(t,x)  (SYM(t)->type= (x))
#define CHGVALUE(t,x)  (SYM(t)->value= (x))
#define CHGTEXT(t,x) ((t)->text= (x))
#define CHGSNO(t,x) ((t)->sym_no= (x)->sym_no)
	/*:62*/	/*65:*/
	#line 2019 "web2w.w"

extern void def_macro(token*eq,int tag);
#define DEF_MACRO(tag)   def_macro(last_token,tag)
	/*:65*/	/*72:*/
	#line 2221 "web2w.w"

extern int pp_lex(void);
extern void pp_error(const char*message);
	/*:72*/	/*83:*/
	#line 2437 "web2w.w"

#define USE(T) (T)->sym_ptr->use_count++;
#define USE_NMACRO(T) USE(T); propagate_use((T)->sym_ptr);
	/*:83*/	/*85:*/
	#line 2455 "web2w.w"

extern void propagate_use(symbol*s);
	/*:85*/	/*91:*/
	#line 2610 "web2w.w"

extern long int getval(token*t);
	/*:91*/	/*93:*/
	#line 2652 "web2w.w"

#define SETVAL(t,val) SYM(t)->value= val
	/*:93*/	/*101:*/
	#line 2821 "web2w.w"

token*join(int tag,token*left,token*right,long int value);
	/*:101*/	/*118:*/
	#line 3142 "web2w.w"

#define IGN(t) ((t)->tag= CIGNORE)
	/*:118*/	/*123:*/
	#line 3236 "web2w.w"

#define LNK(from,to) ((from)?(seq((from),(to)),(from)->link= (to)):0)
	/*:123*/	/*137:*/
	#line 3543 "web2w.w"

extern void pvar_string(token*id,token*val);
	/*:137*/	/*140:*/
	#line 3608 "web2w.w"

void pchar2string(token*id,token*arg);
	/*:140*/	/*157:*/
	#line 4010 "web2w.w"

extern void clabel(token*t,int reference);
	/*:157*/	/*159:*/
	#line 4044 "web2w.w"

extern int exit_no;
#define TOK_RETURN add_token(PRETURN)->sym_no= exit_no
	/*:159*/	/*172:*/
	#line 4275 "web2w.w"

#define UP(from,to) ((from)->up= (to))
	/*:172*/	/*182:*/
	#line 4525 "web2w.w"

extern token*winsert_case(token*t,token*s);
	/*:182*/	/*189:*/
	#line 4743 "web2w.w"

extern void for_loop_variable(token*id,int line_no,int to,int direction);
	/*:189*/	/*194:*/
	#line 4939 "web2w.w"

extern void wsemicolon(token*p,token*t);
extern void wend(token*p,token*t);
	/*:194*/	/*202:*/
	#line 5052 "web2w.w"

extern unsigned int param_mask,param_bit;
#define SIGN_BIT (~(((unsigned int)~0)>>1))
#define START_PARAM (param_mask= 0,param_bit= SIGN_BIT)
#define NEXT_PARAM  (param_bit= param_bit>>1,CHECK(param_bit!=0,"Too many parameters"))
#define REF_PARAM   (param_mask= param_mask|param_bit)
	/*:202*/	/*209:*/
	#line 5192 "web2w.w"

extern void wreturn(token*t,int tail,token*link);
	/*:209*/	/*214:*/
	#line 5286 "web2w.w"

extern int wlocal_value(token*t,token*begin,token*end);
	/*:214*/	/*224:*/
	#line 5444 "web2w.w"

extern FILE*logfile;
	/*:224*/	/*231:*/
	#line 5650 "web2w.w"

#include <stdlib.h>
#include <stdio.h>
#define MESSAGE(...) (fprintf(logfile,__VA_ARGS__),fflush(logfile))
#define ERROR(...)   (fprintf(logfile,"ERROR: "),\
              MESSAGE(__VA_ARGS__),fprintf(logfile,"\n"),exit(1))
#define CHECK(condition,...) (!(condition)? ERROR(__VA_ARGS__):0)
	/*:231*/	/*232:*/
	#line 5660 "web2w.w"

#define THE_TOKEN(t) "%d\t%d: %s\t[%s]\n",\
   t->line_no,t->sequence_no,token2string(t),tagname(t->tag)
	/*:232*/	/*234:*/
	#line 5670 "web2w.w"

typedef enum{dbgnone= 0x0,
dbgbasic= 0x1,
dbgflex= 0x2,
dbglink= 0x4,
dbgtoken= 0x8,
dbgid= 0x10,
dbgpascal= 0x20,
dbgexpand= 0x40,
dbgbison= 0x80,
dbgparse= 0x100,
dbgcweb= 0x200,
dbgjoin= 0x400,
dbgstring= 0x800,
dbgstmt= 0x1000,
dbgslash= 0x2000,
dbgmacro= 0x4000,
dbgarray= 0x8000,
dbgreturn= 0x10000,
dbgsemicolon= 0x20000,
dbgbreak= 0x40000,
dbgtypes= 0x80000
}debugmode;
extern debugmode debugflags;
extern int ww__flex_debug;
	/*:234*/	/*236:*/
	#line 5722 "web2w.w"

#define DBG(flags,...) {if(debugflags & flags) MESSAGE(__VA_ARGS__);}
#define DBGTOKS(flags, from,to)  { if (debugflags & flags) \
{ token *t= from;  MESSAGE("<<");\
  while (t!=to) {  MESSAGE("%s ",token2string(t)); t= t->next;}\
MESSAGE(">>\n"); }}

#define TAG(t) (t?tagname(t->tag):"NULL")

#define DBGTREE(flags,t) DBG(flags,"%s -> %s | %s | %ld\n",TAG(t),\
        TAG(t->previous),TAG(t->next),t->value)
	/*:236*/
	#line 1109 "web2w.w"

	/*:3*/
